VERSION 5.00
Object = "{248DD890-BB45-11CF-9ABC-0080C7E7B78D}#1.0#0"; "MSWINSCK.OCX"
Begin VB.Form Form1 
   BorderStyle     =   4  'Fixed ToolWindow
   Caption         =   "DemoServer"
   ClientHeight    =   780
   ClientLeft      =   45
   ClientTop       =   315
   ClientWidth     =   2955
   Icon            =   "Form1.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   780
   ScaleWidth      =   2955
   ShowInTaskbar   =   0   'False
   StartUpPosition =   3  'Windows Default
   Visible         =   0   'False
   Begin MSWinsockLib.Winsock Winsock 
      Index           =   0
      Left            =   660
      Top             =   180
      _ExtentX        =   741
      _ExtentY        =   741
      _Version        =   393216
      LocalPort       =   8018
   End
   Begin DemoServer.NotifyIcon NotifyIcon 
      Left            =   60
      Top             =   120
      _ExtentX        =   847
      _ExtentY        =   900
   End
   Begin VB.Menu mnuTrayPopup 
      Caption         =   "TrayPopup"
      Visible         =   0   'False
      Begin VB.Menu mnuTrayPopupExit 
         Caption         =   "E&xit DemoServer"
      End
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
'
'Requires references to:
'   Microsoft ActiveX Data Objects 2.5 Library
'   A Demo Public Class Lib for PBDemo
'Uses external components:
'   Microsoft Winsock Control 6.0
'

Private Const MDBNAME As String = "USPresidents.mdb"
Private Const PROVIDERSTRING As String = _
    "Provider=Microsoft.Jet.OLEDB.4.0;Jet OLEDB:Engine Type=5;Data Source='$MDB$'"

Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" ( _
    ByRef Destination As Any, _
    ByRef Source As Any, _
    ByVal Length As Long)

Private Connection As ADODB.Connection
Attribute Connection.VB_VarHelpID = -1
Private StmInbound() As ADODB.Stream
Private SizeInbound() As Long 'Size from message header.
Private ClientCount As Integer
Private PBIn As PropertyBag
Private PBOut As PropertyBag
Private Recordset As ADODB.Recordset

Private Sub ProcessMsg(ByVal Index As Integer, ByRef Contents() As Byte)
    Dim Method As String
    Dim Path As String
    Dim DirRoot As PBDemoTreeLib.Node
    
    Set PBIn = New PropertyBag
    PBIn.Contents = Contents
    Set PBOut = New PropertyBag
    Method = PBIn.ReadProperty("Method")
    With PBOut
        .WriteProperty "Method", Method
        Select Case UCase$(Method)
            Case "ADD"
                .WriteProperty "Sum", PBIn.ReadProperty("A") + PBIn.ReadProperty("B")
            Case "DIR"
                Set DirRoot = New PBDemoTreeLib.Node
                With DirLister
                    .Start PBIn.ReadProperty("Dir"), dlNormal, "*.*"
                    Do While .Dir(Path)
                        DirRoot.Add DirRoot.Create("", Path)
                    Loop
                End With
                .WriteProperty "List", DirRoot
                Set DirRoot = Nothing
            Case "HOMESTATES"
                Set Recordset = New Recordset
                With Recordset
                    .CursorLocation = adUseClient
                    .Open "SELECT * FROM [HomeStates]", _
                          Connection, adOpenStatic, adLockReadOnly, adCmdText
                    Set .ActiveConnection = Nothing
                End With
                .WriteProperty "Recordset", Recordset
                Recordset.Close
                Set Recordset = Nothing
            Case "PRESIDENTSALL"
                Set Recordset = New Recordset
                With Recordset
                    .CursorLocation = adUseClient
                    .Open "SELECT * FROM [Presidents]", _
                          Connection, adOpenStatic, adLockReadOnly, adCmdText
                    Set .ActiveConnection = Nothing
                End With
                .WriteProperty "Recordset", Recordset
                Recordset.Close
                Set Recordset = Nothing
            Case "PRESIDENTSWHEREHOMESTATE"
                Set Recordset = New Recordset
                With Recordset
                    .CursorLocation = adUseClient
                    .Open "SELECT * FROM [Presidents] " _
                        & "WHERE [Home State] = '" & PBIn.ReadProperty("HomeState") & "'", _
                          Connection, adOpenStatic, adLockReadOnly, adCmdText
                    Set .ActiveConnection = Nothing
                End With
                .WriteProperty "Recordset", Recordset
                Recordset.Close
                Set Recordset = Nothing
            Case Else
                .WriteProperty "Method", "Error"
                .WriteProperty "Number", 1
                .WriteProperty "Description", "Unknown method " & Method
        End Select
        Contents = .Contents
    End With
    With Winsock(Index)
        .SendData CLng(UBound(Contents) + 1)
        .SendData Contents
    End With
End Sub

Private Sub UpdateStatus()
    NotifyIcon.ToolTip = App.EXEName & " Active, " & CStr(ClientCount) & " clients"
End Sub

Private Sub Form_Load()
    ChDir App.Path
    ChDrive App.Path
    With NotifyIcon
        Set .Icon = Icon
        .ToolTip = App.EXEName
        .MinimizeToTray Me
    End With
    Set Connection = New ADODB.Connection
    Connection.Open Replace$(PROVIDERSTRING, "$MDB$", MDBNAME)
    ReDim StmInbound(1 To 1)
    ReDim SizeInbound(1 To 1)
    With Winsock(0)
        .Bind
        .Listen
    End With
    UpdateStatus
End Sub

Private Sub Form_Unload(Cancel As Integer)
    Dim I As Integer
    
    Connection.Close
    Winsock(0).Close
    For I = 1 To Winsock.ubound
        If Winsock(I).State <> sckClosed Then
            Winsock(I).Close
            StmInbound(I).Close
        End If
    Next
End Sub

Private Sub mnuTrayPopupExit_Click()
    Unload Me
End Sub

Private Sub NotifyIcon_ContextMenu()
    PopupMenu mnuTrayPopup, vbPopupMenuRightButton, , , mnuTrayPopupExit
End Sub

Private Sub Winsock_Close(Index As Integer)
    Winsock(Index).Close
    StmInbound(Index).Close
    SizeInbound(Index) = 0
    ClientCount = ClientCount - 1
    UpdateStatus
End Sub

Private Sub Winsock_ConnectionRequest(Index As Integer, ByVal requestID As Long)
    Dim I As Integer
    
    For I = 1 To Winsock.ubound
        If Winsock(I).State = sckClosed Then Exit For
    Next
    If I > Winsock.ubound Then
        Load Winsock(I)
        ReDim Preserve StmInbound(1 To I)
        Set StmInbound(I) = New ADODB.Stream
        ReDim Preserve SizeInbound(1 To I)
    End If
    With StmInbound(I)
        .Open
        .Type = adTypeBinary
    End With
    SizeInbound(I) = 0
    Winsock(I).Accept requestID
    ClientCount = ClientCount + 1
    UpdateStatus
End Sub

Private Sub Winsock_DataArrival(Index As Integer, ByVal bytesTotal As Long)
    Dim Chunk() As Byte
    
    Winsock(Index).GetData Chunk
    With StmInbound(Index)
        .Write Chunk
        If SizeInbound(Index) = 0 And .Position >= 4 Then
            'We now have size of next msg.
            .Position = 0
            Chunk = .Read(4)
            CopyMemory SizeInbound(Index), Chunk(0), 4
            .Position = .Size
        End If
        If SizeInbound(Index) > 0 Then
            'We know the next msg's size.
            If .Size >= SizeInbound(Index) + 4 Then
                'Extract and process msg.
                .Position = 4
                Chunk = .Read(SizeInbound(Index))
                ProcessMsg Index, Chunk
                'Clear for next msg.
                SizeInbound(Index) = 0
                .Position = 0
                .SetEOS
            End If
        End If
    End With
End Sub

Private Sub Winsock_Error(Index As Integer, ByVal Number As Integer, Description As String, ByVal Scode As Long, ByVal Source As String, ByVal HelpFile As String, ByVal HelpContext As Long, CancelDisplay As Boolean)
    Debug.Print "WskErr", Index, Number, Description
    Winsock(Index).Close
End Sub

